<template>
  <div>
    <MglGeojsonLayer
      :source-id="uuid"
      :source="geojson"
      :layer-id="uuid"
      :layer="layer"
    />
    <MglImageLayer
      :source-id="uuid"
      :clear-source="false"
      :replace-source="false"
      :layer-id="`fill-${uuid}`"
      :layer="fillLayer"
    />

    <MglMarker v-for="(page, i) in pages" :key="i" :coordinates="page | center">
      <div slot="marker">
        <div>Page: {{ i + 1 }}</div>
        <div>Scale: 1:{{ Math.round(1 / pageScale(page)) }}</div>
      </div>
    </MglMarker>
  </div>
</template>
<script>
import { uuid, get, boundsFor, filterInPlace } from "~/lib/utils";
import * as Turf from "@turf/turf";
import StyleLayer from "./StyleLayer";

import * as UTM from "utm";

const POINTS_TO_INCHES = 1 / 72;
const INCHES_TO_METERS = 0.0254;
const pdfPointsToMeters = (points) =>
  points * POINTS_TO_INCHES * INCHES_TO_METERS;
const metersToPDFPoints = (meters) =>
  meters / (POINTS_TO_INCHES * INCHES_TO_METERS);

const PAGE_SIZES = {
  LETTER: { height: 792.0, width: 612.0 },
};

function UTMOffsetLL({ easting, northing, zoneNum, zoneLetter }, east, north) {
  const ll = UTM.toLatLon(
    easting + east,
    northing + north,
    zoneNum,
    zoneLetter
  );

  return [ll.longitude, ll.latitude];
}

function UTMPagePolygon(utmPage) {
  const centerUTM = utmPage.center;
  const pageWidth = utmPage.width;
  const pageHeight = utmPage.height;

  const r = [
    UTMOffsetLL(centerUTM, -pageWidth / 2, -pageHeight / 2),
    UTMOffsetLL(centerUTM, pageWidth / 2, -pageHeight / 2),
    UTMOffsetLL(centerUTM, pageWidth / 2, pageHeight / 2),
    UTMOffsetLL(centerUTM, -pageWidth / 2, pageHeight / 2),
    UTMOffsetLL(centerUTM, -pageWidth / 2, -pageHeight / 2),
  ];

  return {
    type: "Polygon",
    coordinates: [r],
  };
}

// flip width/height of page if ratio is less than 1:
function orient(page, ratio) {
  if (ratio < 1) return { width: page.height, height: page.width };
  else return page;
}

function UTMPageContainingBounds(bounds, ratio) {
  let center = UTM.fromLatLon(
    (bounds[1] + bounds[3]) / 2,
    (bounds[0] + bounds[2]) / 2
  );
  const latLngs = [
    [bounds[0], bounds[1]],
    [bounds[0], bounds[3]],
    [bounds[2], bounds[1]],
    [bounds[2], bounds[3]],
  ];

  const utms = latLngs.map((ll) =>
    UTM.fromLatLon(ll[1], ll[0], center.zoneNum)
  );

  const utmBounds = boundsFor(utms);
  let metersWide = utmBounds[1][0] - utmBounds[0][0];
  let metersHigh = utmBounds[1][1] - utmBounds[0][1];

  center = {
    ...center,
    easting: (utmBounds[0][0] + utmBounds[1][0]) / 2,
    northing: (utmBounds[0][1] + utmBounds[1][1]) / 2,
  };

  if (ratio < 1) {
    ratio = 1 / ratio;
  }

  // Goal: metersWide and metersHigh should only increase - and minimally.

  if (metersWide > metersHigh) {
    // landscape: width should wind up larger than height:
    if (metersWide > metersHigh * ratio) {
      // already much wider than height, grow height only:
      metersHigh = metersWide / ratio;
    } else {
      // not much wider than height, grow width only:
      metersWide = metersHigh * ratio;
    }
  } else {
    if (metersHigh > metersWide * ratio) {
      // already much taller than wide, grow width:
      metersWide = metersHigh / ratio;
    } else {
      // not much taller, grow height:
      metersHigh = metersWide * ratio;
    }
  }

  return {
    center: center,
    width: metersWide,
    height: metersHigh,
  };
}

function nearWestEdge(page, lngLat) {
  const { easting } = UTM.fromLatLon(
    lngLat.lat,
    lngLat.lng,
    page.center.zoneNum
  );
  const dist = Math.abs(page.center.easting - page.width / 2 - easting);
  return dist / page.width < 0.05;
}
function nearEastEdge(page, lngLat) {
  const { easting } = UTM.fromLatLon(
    lngLat.lat,
    lngLat.lng,
    page.center.zoneNum
  );
  const dist = Math.abs(page.center.easting + page.width / 2 - easting);
  return dist / page.width < 0.05;
}
function nearSouthEdge(page, lngLat) {
  const { northing } = UTM.fromLatLon(
    lngLat.lat,
    lngLat.lng,
    page.center.zoneNum
  );
  const dist = Math.abs(page.center.northing - page.height / 2 - northing);
  return dist / page.height < 0.05;
}
function nearNorthEdge(page, lngLat) {
  const { northing } = UTM.fromLatLon(
    lngLat.lat,
    lngLat.lng,
    page.center.zoneNum
  );
  const dist = Math.abs(page.center.northing + page.height / 2 - northing);
  return dist / page.height < 0.05;
}
function insidePage(page, lngLat) {
  const { easting, northing } = UTM.fromLatLon(
    lngLat.lat,
    lngLat.lng,
    page.center.zoneNum
  );
  return (
    page.center.easting - page.width / 2 <= easting &&
    easting <= page.center.easting + page.width / 2 &&
    page.center.northing - page.height / 2 <= northing &&
    northing <= page.center.northing + page.height / 2
  );
}

export default {
  props: ["value"],

  data() {
    const id = uuid();
    return {
      uuid: id,

      cancelAddPage: null,
      activePageId: null,

      layer: {
        type: "line",
        source: id,
        layout: {},
        paint: { "line-width": 1, "line-color": ["get", "color"] },
      }, // ['match',['get','type'],'type','page','#00aa00','bbox','#0000aa','#aa0000'] } },
      fillLayer: {
        type: "fill",
        source: id,
        layout: {},
        paint: {
          "fill-opacity": 0.3,
          "fill-color": ["case", ["get", "active"], "red", ["get", "color"]],
        },
      },

      geojson: {
        type: "geojson",
        data: { type: "FeatureCollection", features: [] },
      },
    };
  },

  inject: ["map", "mapbox"],

  components: { StyleLayer },
  filters: {
    upperRightCorner(page) {
      return UTMOffsetLL(page.center, page.width / 2, page.height / 2);
    },
    center(page) {
      return UTMOffsetLL(page.center, 0, 0);
    },
  },
  mapEvents: {
    click(e) {
      var features = this.map
        .queryRenderedFeatures(e.point)
        .filter((f) => f.source == this.uuid);

      let feature = features[0];

      this.geojson.data.features.forEach((f) => {
        if (feature && f.properties.id == feature.properties.id) {
          this.$set(f.properties, "active", true);
        } else {
          this.$set(f.properties, "active", false);
        }
      });

      if (feature) {
        this.activePage = this.pages.find((p) => p.id == feature.properties.id);
      } else {
        this.activePage = null;
      }

      this.updateCursor(e);

      e.preventDefault();
    },
    mousedown(e) {
      // Start a page creation process:
      if (this.cancelAddPage) {
        const startLatLng = e.lngLat;
        let endLatLng;
        const map = this.map;

        const update = (finish) => {
          console.log("UPDATE: ", finish);
          if (!startLatLng && endLatLng) return;

          const bbox = [
            Math.min(startLatLng.lng, endLatLng.lng),
            Math.min(startLatLng.lat, endLatLng.lat),
            Math.max(startLatLng.lng, endLatLng.lng),
            Math.max(startLatLng.lat, endLatLng.lat),
          ];

          const utmPage = UTMPageContainingBounds(bbox, 792.0 / 612.0);

          utmPage.id = uuid();

          filterInPlace(
            this.geojson.data.features,
            (f) => !get(f, "properties.creating"),
            this.$set
          );

          if (finish) {
            const len = this.pages.length;
            this.pages.push(utmPage);

            this.geojson.data.features.push({
              type: "Feature",
              properties: { id: utmPage.id },
              geometry: UTMPagePolygon(utmPage),
            });

            this.cancelAddPage = null;
            this.$emit("input", this.value);
          } else {
            const bboxPoly = Turf.bboxPolygon(bbox);
            bboxPoly.properties = { creating: true };

            this.geojson.data.features.push({
              type: "Feature",
              properties: { creating: true },
              geometry: UTMPagePolygon(utmPage),
            });
            this.geojson.data.features.push(bboxPoly);
          }
        };

        this.onDrag(e, (n) => {
          endLatLng = n.lngLat;

          update(n.type == "mouseup");
        });
      }

      // Drag an already created page:
      if (this.activePage) {
        const nearWest = nearWestEdge(this.activePage, e.lngLat);
        const nearEast = nearEastEdge(this.activePage, e.lngLat);
        const nearNorth = nearNorthEdge(this.activePage, e.lngLat);
        const nearSouth = nearSouthEdge(this.activePage, e.lngLat);
        const inBounds = insidePage(this.activePage, e.lngLat);

        const U = (e) =>
          UTM.fromLatLon(
            e.lngLat.lat,
            e.lngLat.lng,
            this.activePage.center.zoneNum
          );

        if (nearWest) {
          if (nearSouth) {
            this.onDrag(e, (e) =>
              this.updatePage(this.activePage, {
                w: U(e).easting,
                s: U(e).northing,
              })
            );
          } else if (nearNorth) {
            this.onDrag(e, (e) =>
              this.updatePage(this.activePage, {
                w: U(e).easting,
                n: U(e).northing,
              })
            );
          } else {
            this.onDrag(e, (e) =>
              this.updatePage(this.activePage, { w: U(e).easting })
            );
          }
        } else if (nearEast) {
          if (nearSouth) {
            this.onDrag(e, (e) =>
              this.updatePage(this.activePage, {
                e: U(e).easting,
                s: U(e).northing,
              })
            );
          } else if (nearNorth) {
            this.onDrag(e, (e) =>
              this.updatePage(this.activePage, {
                e: U(e).easting,
                n: U(e).northing,
              })
            );
          } else {
            this.onDrag(e, (e) =>
              this.updatePage(this.activePage, { e: U(e).easting })
            );
          }
        } else if (nearSouth) {
          this.onDrag(e, (e) =>
            this.updatePage(this.activePage, { s: U(e).northing })
          );
        } else if (nearNorth) {
          this.onDrag(e, (e) =>
            this.updatePage(this.activePage, { n: U(e).northing })
          );
        } else if (inBounds) {
          let last = e.lngLat;
          this.onDrag(e, (e) => {
            const diff = {
              lng: e.lngLat.lng - last.lng,
              lat: e.lngLat.lat - last.lat,
            };
            let centerLL = UTM.toLatLon(
              this.activePage.center.easting,
              this.activePage.center.northing,
              this.activePage.center.zoneNum,
              this.activePage.center.zoneLetter
            );

            centerLL.latitude += diff.lat;
            centerLL.longitude += diff.lng;

            this.activePage.center = UTM.fromLatLon(
              centerLL.latitude,
              centerLL.longitude
            );
            this.updatePage(this.activePage);

            last = e.lngLat;
          });
        }
      }
    },

    mousemove(e) {
      if (this._dragCBs) {
        e.preventDefault();

        this._dragCBs.forEach((cb) => cb(e));
        return;
      }

      if (this.cancelAddPage) return;

      if (this.activePage) {
        this.updateCursor(e);
      } else {
        let features = this.pagesUnderPoint(e.point);
        if (features.length) {
          this.map.getCanvas().style.cursor = "pointer";
        } else {
          this.map.getCanvas().style.cursor = "";
        }
      }
    },

    mouseup(e) {
      if (this._dragCBs) {
        e.preventDefault();

        if (!(this._lastDragEvent && this._lastDragEvent.type == "mousedown")) {
          // dont call through for "clicks", just "drags" (i.e. mousemove in between)
          this._dragCBs.forEach((cb) => cb(e));
        }

        this._dragCBs = null;
      }
    },
  },

  mounted() {
    this._mapListeners = {};

    for (var k in this.$options.mapEvents) {
      const cb = (this._mapListeners[k] = this.$options.mapEvents[k].bind(
        this
      ));

      this.map.on(k, cb);
    }
  },

  beforeDestroy() {
    for (var k in this._mapListeners) {
      this.map.off(k, this._mapListeners[k]);
    }

    try {
      this.map.removeLayer("fill-" + this.uuid);
      this.map.removeLayer(this.uuid);
    } catch (x) {
      console.log("layer does not exist");
    }

    try {
      this.map.removeSource(this.uuid);
    } catch (x) {
      console.log("source does not exist");
    }
  },

  computed: {
    activePage: {
      set(page) {
        return (this.activePageId = (page && page.id) || null);
      },
      get() {
        const active = this.activePageId;
        if (!active) return null;
        return this.pages.find((p) => p.id == active);
      },
    },
    pages: {
      set(pages) {
        if (!this.value) {
          const r = { pages: pages };
          this.$emit("input", r);
          return r.pages;
        }

        this.$set(this.value, "pages", pages);
      },
      get(pages) {
        if (!this.value) {
          const r = { pages: [] };
          this.$emit("input", r);
          return r.pages;
        }
        if (!this.value.pages) {
          this.$set(this.value, "pages", []);
          return this.value.pages;
        }
        return this.value.pages;
      },
    },
  },

  watch: {
    pages: {
      handler() {
        this.renderPages();
      },
      immediate: true,
    },
  },

  methods: {
    pageScale(page) {
      const pageSize = orient(
        PAGE_SIZES[page.size] || PAGE_SIZES.LETTER,
        page.height / page.width
      );
      const pageWidthInMeters = pdfPointsToMeters(pageSize.width);

      return pageWidthInMeters / page.width;
    },
    setPageScale(page, scale) {
      const pageSize = orient(
        PAGE_SIZES[page.size] || PAGE_SIZES.LETTER,
        page.height / page.width
      );

      page.width = pdfPointsToMeters(pageSize.width) / scale;
      page.height = pdfPointsToMeters(pageSize.height) / scale;

      this.updatePage(page);
    },
    renderPages() {
      this.geojson.data.features = this.pages.map((utmPage) => ({
        type: "Feature",
        properties: {
          id: utmPage.id,
          active: utmPage.id == this.activePageId,
        },
        geometry: UTMPagePolygon(utmPage),
      }));
    },
    onDrag(e, callback) {
      e.preventDefault();

      this._lastDragEvent = e;
      if (!this._dragCBs) {
        this._dragCBs = [(e) => (this._lastDragEvent = e)];
      }

      this._dragCBs.push(callback);
    },
    updatePage(page, adjustment) {
      if (adjustment) {
        let oldB = {
          w: page.center.easting - page.width / 2,
          e: page.center.easting + page.width / 2,
          s: page.center.northing - page.height / 2,
          n: page.center.northing + page.height / 2,
        };

        let newB = { ...oldB, ...adjustment };
        let width, height;

        if ("e" in adjustment || "w" in adjustment) {
          width = newB.e - newB.w;
        }
        if ("n" in adjustment || "s" in adjustment) {
          height = newB.n - newB.s;
        }

        const avg = (...args) => {
          const valid = args.filter((a) => typeof a == "number" && !isNaN(a));
          return valid.reduce((a, b) => a + b, 0) / valid.length;
        };

        let widthRatio = width / (oldB.e - oldB.w);
        let heightRatio = height / (oldB.n - oldB.s);

        // console.log(`W: ${width.toFixed(0)} * ${widthRatio.toFixed(3)} H: ${height.toFixed(0)} * ${heightRatio.toFixed(3)}`);

        let ratio = avg(widthRatio, heightRatio);
        widthRatio = ratio;
        heightRatio = ratio;

        width = page.width * widthRatio;
        height = page.height * heightRatio;

        const widthDiff = width - page.width;
        const heightDiff = height - page.height;

        page.width = width;
        page.height = height;

        if ("e" in adjustment) {
          page.center.easting += widthDiff / 2;
        }
        if ("w" in adjustment) {
          page.center.easting -= widthDiff / 2;
        }
        if ("n" in adjustment) {
          page.center.northing += heightDiff / 2;
        }
        if ("s" in adjustment) {
          page.center.northing -= heightDiff / 2;
        }
      }

      this.$emit("input", this.value);

      const feature = this.geojson.data.features.find(
        (f) => f.properties.id == page.id
      );
      const newGeom = UTMPagePolygon(page);

      feature.geometry = newGeom;
    },
    updateCursor(e) {
      if (this.activePage) {
        const nearWest = nearWestEdge(this.activePage, e.lngLat);
        const nearEast = nearEastEdge(this.activePage, e.lngLat);
        const nearNorth = nearNorthEdge(this.activePage, e.lngLat);
        const nearSouth = nearSouthEdge(this.activePage, e.lngLat);
        const inBounds = insidePage(this.activePage, e.lngLat);

        let partial = "";

        if (nearNorth) partial = "n";
        else if (nearSouth) partial = "s";

        if (nearWest) partial = partial + "w";
        else if (nearEast) partial = partial + "e";

        if (partial) {
          this.map.getCanvas().style.cursor = `${partial}-resize`;
        } else if (inBounds) {
          this.map.getCanvas().style.cursor = "move";
        } else {
          this.map.getCanvas().style.cursor = "";
        }
      }
    },
    pagesUnderPoint(point) {
      return this.map
        .queryRenderedFeatures(point)
        .filter((f) => f.source == this.uuid);
    },
    deletePage(page) {
      if (!page) page = this.activePage;
      if (!page) throw new Error("Couldn't find page");

      filterInPlace(this.pages, (p) => !(p.id == page.id), this.$set);

      if (page.id == this.activePageId) {
        this.activePageId = null;
      }

      this.renderPages();
    },
    async addPage() {
      this.cancelAddPage = () => {
        this.cancelAddPage = null;
      };
    },
  },
};
</script>
